#include "my.h"
#define SERVEUR

void reset(void);
int  initCaseString(void);
void tempFanlocateTable(char *valeur);
void cmdAllFan(int value);
int socketFlg=1;



int initCaseString(){	 
/** Description : Initialise les variables caseString et caseStringCmd */
/** Valeur de retour : 
	renvoi toujours ok=0
*/ 
     sprintf(caseString[1],"Read configure");
     sprintf(caseString[2],"Read Temperature");
     sprintf(caseString[3],"Read Fans");
     sprintf(caseString[4],"Read StateTemp");
     sprintf(caseString[5],"read locate table GPIO"); 
     sprintf(caseString[6],"read locate table temp/fan");
     sprintf(caseString[7],"read locate table IN/OUT GPIO\n");
     sprintf(caseString[8],"reset serveur (but not load the defaut config");
     sprintf(caseString[9],"reset serveur and load the defaut config\n");
     sprintf(caseString[10],"autoMod fan = OFF"); 
     sprintf(caseString[11],"autoMod fan = ON\n"); 
     sprintf(caseString[12],"autoMod GPIO = OFF"); 
     sprintf(caseString[13],"autoMod GPIO = ON\n"); 
     sprintf(caseString[14],"autoMod GPIO IN/OUT = ON"); 
     sprintf(caseString[15],"autoMod GPIO IN/OUT = OFF\n"); 
     sprintf(caseString[16],"stop all fan");
     sprintf(caseString[17],"start all fan (max value)\n");
     sprintf(caseString[18],"Defaut configuration (defaut.txt)");
     sprintf(caseString[19],"Physics configuration (physics.txt)");
     sprintf(caseString[20],"Calibration configuration (calib.txt)");
     sprintf(caseString[21],"Test configuration (test.txt)");
     	  
     sprintf(caseStringCmd[0],"cmdAllFan");  
     sprintf(caseStringCmd[1],"autoMod");  
     sprintf(caseStringCmd[2],"tempOnOff");  
     sprintf(caseStringCmd[3],"fanOutOnOff");  
     sprintf(caseStringCmd[4],"photodiodeOnOff");  
     sprintf(caseStringCmd[5],"tempNbMoy");  
     sprintf(caseStringCmd[6],"photodiodeNbMoy");  
     sprintf(caseStringCmd[7],"nbSeuilTemp");     
     sprintf(caseStringCmd[8],"toto1");  
     sprintf(caseStringCmd[9],"toto2"); 
     sprintf(caseStringCmd[10],"seuilTempIncrease"); 
     sprintf(caseStringCmd[11],"seuilTempDecrease"); 
     sprintf(caseStringCmd[12],"seuilGPOLocateTable"); 
     sprintf(caseStringCmd[13],"GPIO"); 
     sprintf(caseStringCmd[14],"tempFanSensor"); 
     sprintf(caseStringCmd[15],"ReadTempFanTable");   
     sprintf(caseStringCmd[16],"End");  
     sprintf(caseStringCmd[17],"Kill");  
     sprintf(caseStringCmd[18],"ResetState");  
     sprintf(caseStringCmd[19],"ResetAll");  
     sprintf(caseStringCmd[20],"ReadGPITable"); 
     sprintf(caseStringCmd[21],"ReadFan"); 
     sprintf(caseStringCmd[22],"ReadTempState");
     sprintf(caseStringCmd[23],"ReadConfig"); 
     sprintf(caseStringCmd[24],"ReadTemperature");
     sprintf(caseStringCmd[25],"toto3");
     sprintf(caseStringCmd[26],"WrSeuilInOutGPOLocateTable0");
     sprintf(caseStringCmd[27],"WrSeuilInOutGPOLocateTable1");
     sprintf(caseStringCmd[28],"RdSeuilInOutGPOLocateTable");
     sprintf(caseStringCmd[29],"nbSeuilPhotodiode");
     sprintf(caseStringCmd[30],"seuilPhotodiodeIncrease");
     sprintf(caseStringCmd[31],"seuilPhotodiodeDecrease");
	 return(0);
}


void purger(void){
/** Description : Cette fonction permet de purger le buffer clavier */ 
    int c;
    while ((c = getchar()) != '\n' && c != EOF){}
}

void clean (char *chaine){
/** Description : Cette fonction permet de purger la chaine de caractere et le buffer clavier 
	purger()*/ 
    char *p = strchr(chaine, '\n');
    if (p){
        *p = 0;
    }
    else {
        purger();
    }
}

int readConfigFile(char *fileName) {
/** Description : ouvre un fichier de configuration et le decripte. 
Le nom du fichier est donne dans le parametre fileName */
/** Valeur de retour : 
	0 = ok
	-1 = pb
*/ 
/** detail de la fonction :  */

	FILE *fichier; 
	int nbLu;
	int nb=4096*10;

	/** ouvre le fichier */
	fichier = fopen(fileName,"r"); 
	if(fichier==NULL) return -1;

	/** alloue de la memoire et lit le fichier dans variable bloc */
	char *bloc;
	bloc = (char *) malloc(nb*sizeof(char));   
	nbLu = fread(bloc, sizeof(char), nb, fichier); 
    bloc[nbLu]= '\0';
    
	/** ferme le fichier */
	fclose(fichier);
 
	/** pour le contenu du fichier appel de la fonction parse2() */
	socketFlg=0;
    int find=0;
    int debut =0;
    do { 
        find = parse2(bloc,debut);
        debut += find;
    } while( find !=0);

	socketFlg=1;
    return(0);
}


int strpos(char *chaine, char *ch)
/** Description : Trouve la position de la premiere occurence de la chaine. */
{
   char *res = strstr(chaine, ch);
   
   if(res == NULL)
   {
     return -1 ;
   }
   return (int)(res-chaine) ;
}

int parse2(char *bloc,int debut) {
/** Description : Permet de decouper le bloc et d'affecter les variables ou faire des actions en fonction des balises */ 
/** Valeur de retour : */
/** -> 0 = fin pas trouve de balise <>*/
/**	-> val = position dans le bloc de la prochaine balise */ 
/** detail de la fonction :  */

 int pos=0,pos2;
 int posTab=0,posTab2;
 char tableau[SIZE_STRING];
 char parametre[SIZE_STRING];
 char finParametre[SIZE_STRING];
 char valeur[BLOC_SIZE];
 int cpt=0,cpt2,cpt3,qui=0;
 int flgCmd;
 int lg;
 unsigned int myVal,myVal2;  

 /** --> cherche le debut et fin de balise "<" ">" */
 pos = strpos(&bloc[debut],"<");
 pos2 = strpos(&bloc[debut],">");

 if(pos >=0) {      
    pos++;
	int i;
    /** --> cherche le nom de la balise */
    for(i=0 ; i<pos2-pos; i++) parametre[i]=bloc[i+debut+pos];
    parametre[i]='\0';
	sprintf(finParametre,"</%s>",parametre);
	
	/** --> cherche la valeur de la balise */
    pos= strpos(&bloc[debut+pos2], finParametre);
	int j=0;
	for(j=0, i=pos2+1 ; j<(pos-1); j++,i++){ 
		valeur[j]=bloc[i+debut];
	}	
    valeur[j]='\0';
    
	/** --> cherche la correspondance de cette balise avec la liste dans
	le tableau caseStringCmd[] */
	for(qui=0,flgCmd=0; qui<NB_CASE_CMD;qui++) {
        if((int) strstr(parametre,caseStringCmd[qui]) !=0) {
                 flgCmd=1;
                 break;
        }
      }
    
    
    if((!flgCmd)) return((pos)+(pos2)+strlen(finParametre));
    
    int fan;
    printf("qui=%d\n",qui);
    printf("valeur=%s\n",valeur);
    
	/** --> en fonction de l'index trouve via le tableau caseStringCmd[]
	le programme va effectuer les actions actions (switch(qui) -> case */
	/* si SERVEUR est dfini, il va aussi envoyer des messages vers le client pour informer que l'ordre est recu*/
    switch(qui) {
    case 0: 
         sscanf(valeur,"%x",&fan);
         cmdAllFan(fan);
    #ifdef SERVEUR 
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER); 
    #endif         
    break;
    case 1: autoMod = atoi(valeur);
    #ifdef SERVEUR     
          sprintf(bloc,"%s accepted",parametre);
          if(socketFlg) write(client_socket,bloc, SIZE_BUFFER); 
    #endif
    break; 
    case 2: sscanf(valeur,"%x",&tempOnOff);
    #ifdef SERVEUR
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER); 
    #endif
    break; 
    case 3: sscanf(valeur,"%x",&fanOutOnOff);
    #ifdef SERVEUR            
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
    #endif
    break; 
    case 4: sscanf(valeur,"%x",&photodiodeOnOff);
    #ifdef SERVEUR    
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
    #endif
    break; 
    case 5: tempNbMoy = atoi(valeur);
    #ifdef SERVEUR    
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
    #endif            
    break; 
    case 6: photodiodeNbMoy = atoi(valeur);
    #ifdef SERVEUR  
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
    #endif    
    break; 
    case 7: nbSeuilTemp = atoi(valeur);
    #ifdef SERVEUR  
            sprintf(bloc,"%s accepted",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER); 
    #endif    
    break;
	case 10: 
         posTab2=0;
         posTab =0;
         cpt=0;
         for(cpt=0; cpt<nbSeuilTemp-1; cpt ++) {
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            }	
            tableau[j]='\0';
            posTab2+=posTab+1; 
            sscanf(tableau,"%f",&seuilTemp[cpt]);
            //seuilTemp[cpt] = atoi(tableau);
         } 
         sscanf(&valeur[posTab2],"%f",&seuilTemp[cpt]);         
    #ifdef SERVEUR  
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
    break;
    case 11: 
         posTab2=0;
         posTab =0;
         
         for(cpt=0; cpt<nbSeuilTemp-1; cpt ++) {
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            }	
            tableau[j]='\0';
            posTab2+=posTab+1; 
            sscanf(tableau,"%f",&seuilTempDecrease[cpt]);
         } 
         sscanf(&valeur[posTab2],"%f",&seuilTempDecrease[cpt]);         
    #ifdef SERVEUR  
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
    break; 
    case 12: 
         posTab2=0;
         posTab =0;
          
         for(cpt2=0;cpt2<2;cpt2++) {  
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            } 
            tableau[j]='\0';
            posTab2+=posTab+1;
            if(cpt2==0) {
               sscanf(tableau,"%d",&qui);
            }
            if(cpt2==1) {           
                  for(cpt=0,myVal=0, myVal2=0 ; cpt<NB_GPIO ; cpt++) { 
                   //   printf("tableau[%d]=%c\n",cpt,tableau[cpt]);   
                      if(tableau[cpt]=='x') myVal += (0<<(NB_GPIO-cpt-1));
                      else myVal += (1<<(NB_GPIO-cpt-1)); 
                      if(tableau[cpt]=='1') myVal2 += (1<<(NB_GPIO-cpt-1));
                      else myVal2 += (0<<(NB_GPIO-cpt-1)); 
                  }
                  maskGPOLocateTable[qui-1]=myVal;
                  seuilGPOLocateTable[qui-1]=myVal2;
            }
            
         }         
    #ifdef SERVEUR           
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
    break; 
    case 13: 
         posTab2=0;
         posTab =0;
         for(cpt2=0;cpt2<3;cpt2++) {                           
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            }	
            tableau[j]='\0';
            posTab2+=posTab+1; 
            if(cpt2==0) {
               sscanf(tableau,"%d",&qui);
            }
            if(cpt2==1) {
               sscanf(tableau,"%d",&myVal);
               directionGPIO[qui]=myVal;
            }            
            if(cpt2==2)sprintf(descriptionGPIO[qui],"%s",tableau);
        } 
        sscanf(&valeur[posTab2],"%s",&descriptionGPIO[cpt][0]);              
    #ifdef SERVEUR          
        sprintf(bloc,"%s accepted",parametre);
        if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
    break; 
    case 14: tempFanlocateTable(valeur);  
     #ifdef SERVEUR   
             sprintf(bloc,"%s accepted",parametre);
             if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif              
    break; 
    case 15: numSonde = atoi(valeur);  
             printf("numSonde=%d\n",numSonde);
             bloc[0]='\0';
             for(cpt=0; cpt<nbSeuilTemp; cpt++) {    
                for(cpt2=0; cpt2<NB_FAN; cpt2++) {                 
                   sprintf(bloc,"%s%2x\t\0",bloc,tempFanTable[numSonde][cpt][cpt2]);
                }
                sprintf(bloc,"%s\n\0",bloc);
             }         
            // sprintf(bloc,"%s accepted",bloc);
    #ifdef SERVEUR          
             if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif 
    break;                      
                   
       case 16:
             fin=0;
    #ifdef SERVEUR                
             sprintf(bloc,"%s accepted\0",parametre);
             if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
    #endif             
       break;
       case 17 :
             fin=-1;
    #ifdef SERVEUR                 
             sprintf(bloc,"%s accepted\0",parametre);
             if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
   #endif 
       break;     
       case 18 :  
            reset();
    #ifdef SERVEUR                
            sprintf(bloc,"%s accepted\0",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
   #endif 
       break;
       case 19 :
            readConfigFile("defaut.txt");
            reset();
    #ifdef SERVEUR                
            sprintf(bloc,"Reset all accepted\0");
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
   #endif             
       break;
       case 20 :
             numSonde = atoi(valeur);  
             printf("numSonde=%d\n",numSonde);
             bloc[0]='\0';
             sprintf(bloc,"%smaskGPOLocateTable :\n\0",bloc);
             for(cpt=0; cpt<nbSeuilTemp; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskGPOLocateTable[cpt]);
             }  
             sprintf(bloc,"%s\nseuilGPOLocateTable :\n\0",bloc);
             for(cpt=0; cpt<nbSeuilTemp; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilGPOLocateTable[cpt]);
             }
    #ifdef SERVEUR                
            //sprintf(bloc,"%s accepted\0",parametre);
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
    #endif               
       break;
       case 21:
            bloc[0]='\0';
            for(cpt=0; cpt<NB_FAN; cpt++) {      
                       sprintf(bloc,"%s|%x\t\0",bloc,valeurLuFan[cpt]);
            }  
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
            bloc[0]='\0';
            for(cpt=0; cpt<NB_FAN; cpt++) {      
                        sprintf(bloc,"%s|%x\t\0",bloc,calculFan[cpt]);
            }  
    #ifdef SERVEUR                
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
   #endif 
       break;
       case 22:
            bloc[0]='\0';
            for(cpt=0; cpt<NB_SENSOR; cpt++) {      
                if(tempOnOff&(1<<cpt))     
                  sprintf(bloc,"%s|%d\t\0",bloc,etat[cpt]);
                else
                  sprintf(bloc,"%s|NO\t\0",bloc);                  
            }  
    #ifdef SERVEUR                
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
   #endif 
       break;
             

       case 23:
    #ifdef SERVEUR                
            sprintf(bloc,"tempOnOff=%d\n",tempOnOff);
			sprintf(bloc,"%sphotodiodeOnOff=%d\n",bloc,photodiodeOnOff);
			sprintf(bloc,"%stempNbMoy=%d\n",bloc,tempNbMoy);
			sprintf(bloc,"%sphotodiodeNbMoy=%d\n",bloc,photodiodeNbMoy);
            sprintf(bloc,"%sautoMod=%d\n",bloc,autoMod);
            sprintf(bloc,"%sfanOutOnOff=%d\n",bloc,fanOutOnOff);
            sprintf(bloc,"%sphotodiodeNbMoy=%d\n",bloc,photodiodeNbMoy);
            sprintf(bloc,"%snbSeuilTemp=%d\n",bloc,nbSeuilTemp);
			sprintf(bloc,"%snbSeuilPhotodiode=%d\n",bloc,nbSeuilPhotodiode);			

            sprintf(bloc,"%sseuilTempIncrease=",bloc);
			for(cpt=0; cpt<nbSeuilTemp; cpt++) {
               sprintf(bloc,"%s %f,",bloc,seuilTemp[cpt]);	
			}
            sprintf(bloc,"%s \n",bloc);	
            sprintf(bloc,"%sseuilTempDecrease=",bloc);
			for(cpt=0; cpt<nbSeuilTemp; cpt++) {
               sprintf(bloc,"%s %f,",bloc,seuilTempDecrease[cpt]);	
			}
            sprintf(bloc,"%s \n",bloc);	

			sprintf(bloc,"%smaskGPOLocateTable :\n\0",bloc);
            for(cpt=0; cpt<nbSeuilTemp; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskGPOLocateTable[cpt]);
            }  
            sprintf(bloc,"%s\nseuilGPOLocateTable :\n\0",bloc);
            for(cpt=0; cpt<nbSeuilTemp; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilGPOLocateTable[cpt]);
            }
            sprintf(bloc,"%s\nDescription of GPIO : (0=Out 1=In)\n\0",bloc);
			if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);
			
            for(cpt2=0; cpt2<4; cpt2++) {                   				  
				bloc[0]='\0';
				for(cpt=0; cpt<(NB_GPIO/4); cpt++) {                   
                   sprintf(bloc,"%sDir = %d  Description : %s\n\0",bloc,directionGPIO[(cpt2*(NB_GPIO/4))+cpt],descriptionGPIO[(cpt2*(NB_GPIO/4))+cpt]);
			  }
              if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);
            
			}

			for(cpt3=0; cpt3<NB_SENSOR; cpt3++) {
				printf("numSonde=%d\n",cpt2);
				bloc[0]='\0';
				for(cpt=0; cpt<nbSeuilTemp; cpt++) {    
					for(cpt2=0; cpt2<NB_FAN; cpt2++) {                 
						sprintf(bloc,"%s%2x\t\0",bloc,tempFanTable[cpt3][cpt][cpt2]);
					}
					sprintf(bloc,"%s\n\0",bloc);
				}  
				if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
							usleep(2*10000);

			}

			sprintf(bloc,"valeurLuFan\n");      
            for(cpt=0; cpt<NB_FAN; cpt++) {      
                       sprintf(bloc,"%s|%x\t\0",bloc,valeurLuFan[cpt]);
            }  
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);

			sprintf(bloc,"calculFan\n");      
            for(cpt=0; cpt<NB_FAN; cpt++) {      
                        sprintf(bloc,"%s|%x\t\0",bloc,calculFan[cpt]);
            }  
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);
			            
			sprintf(bloc,"etat\n");      
            for(cpt=0; cpt<NB_SENSOR; cpt++) {      
                if(tempOnOff&(1<<cpt))     
                  sprintf(bloc,"%s|%d\t\0",bloc,etat[cpt]);
                else
                  sprintf(bloc,"%s|NO\t\0",bloc);                  
            }  
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);

			sprintf(bloc,"valeurMoyTemp\n");      
			for(cpt=0; cpt<NB_SENSOR; cpt++) {
               if(tempOnOff&(1<<cpt))      
               sprintf(bloc,"%s|%4.2f\t\0",bloc,valeurMoyTemp[cpt]);
               else
               sprintf(bloc,"%s| NO  \t\0",bloc);
			}        
	        if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
			usleep(2*10000);


				sprintf(bloc,"maskInOutGPOLocateTable0 :\n\0");
				for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskInOutGPOLocateTable0[cpt]);
				}  
				sprintf(bloc,"%s\nseuilInOutGPOLocateTable0 :\n\0",bloc);
				for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilInOutGPOLocateTable0[cpt]);
				}
				if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);

				sprintf(bloc,"maskInOutGPOLocateTable1 :\n\0");
				for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskInOutGPOLocateTable1[cpt]);
				}  
				sprintf(bloc,"%s\nseuilInOutGPOLocateTable1 :\n\0",bloc);
				for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilInOutGPOLocateTable1[cpt]);
				}
				if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);
			
			sprintf(bloc,"seuilPhotodiodeIncrease :\n\0");
            for(cpt=0; cpt<nbSeuilPhotodiode; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilPhotodiodeIncrease[cpt]);
			}

			sprintf(bloc,"%s\seuilPhotodiodeDecrease :\n\0",bloc);
            for(cpt=0; cpt<nbSeuilPhotodiode; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilPhotodiodeDecrease[cpt]);
			}
			if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
			usleep(2*10000);
   #endif 
       break;
       case 24:
         bloc[0]='\0';
         for(cpt=0; cpt<NB_SENSOR; cpt++) {
               if(tempOnOff&(1<<cpt))      
               sprintf(bloc,"%s|%4.2f\t\0",bloc,valeurMoyTemp[cpt]);
               else
               sprintf(bloc,"%s| NO  \t\0",bloc);
         }        
    #ifdef SERVEUR             
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);     
   #endif 
       break;
       case 26:
         posTab2=0;
         posTab =0;
          
         for(cpt2=0;cpt2<2;cpt2++) {  
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            } 
            tableau[j]='\0';
            posTab2+=posTab+1;
            if(cpt2==0) {
               sscanf(tableau,"%d",&qui);
            }
            if(cpt2==1) {           
                  for(cpt=0,myVal=0, myVal2=0 ; cpt<NB_GPIO ; cpt++) { 
                   //   printf("tableau[%d]=%c\n",cpt,tableau[cpt]);   
                      if(tableau[cpt]=='x') myVal += (0<<(NB_GPIO-cpt-1));
                      else myVal += (1<<(NB_GPIO-cpt-1)); 
                      if(tableau[cpt]=='1') myVal2 += (1<<(NB_GPIO-cpt-1));
                      else myVal2 += (0<<(NB_GPIO-cpt-1)); 
                  }
                  maskInOutGPOLocateTable0[qui-1]=myVal;
                  seuilInOutGPOLocateTable0[qui-1]=myVal2;
            }
         }   
    #ifdef SERVEUR           
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
       break;
       case 27:
         posTab2=0;
         posTab =0;
          
         for(cpt2=0;cpt2<2;cpt2++) {  
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            } 
            tableau[j]='\0';
            posTab2+=posTab+1;
            if(cpt2==0) {
               sscanf(tableau,"%d",&qui);
            }
            if(cpt2==1) {           
                  for(cpt=0,myVal=0, myVal2=0 ; cpt<NB_GPIO ; cpt++) { 
                   //   printf("tableau[%d]=%c\n",cpt,tableau[cpt]);   
                      if(tableau[cpt]=='x') myVal += (0<<(NB_GPIO-cpt-1));
                      else myVal += (1<<(NB_GPIO-cpt-1)); 
                      if(tableau[cpt]=='1') myVal2 += (1<<(NB_GPIO-cpt-1));
                      else myVal2 += (0<<(NB_GPIO-cpt-1)); 
                  }
                  maskInOutGPOLocateTable1[qui-1]=myVal;
                  seuilInOutGPOLocateTable1[qui-1]=myVal2;
            }
         }   
    #ifdef SERVEUR           
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif    
       break;   
       case 28 :
             bloc[0]='\0';
             sprintf(bloc,"%smaskInOutGPOLocateTable0 :\n\0",bloc);
             for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskInOutGPOLocateTable0[cpt]);
             }  
             sprintf(bloc,"%s\nseuilInOutGPOLocateTable0 :\n\0",bloc);
             for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilInOutGPOLocateTable0[cpt]);
             }
    #ifdef SERVEUR                
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
    #endif    
             bloc[0]='\0';
             sprintf(bloc,"%smaskInOutGPOLocateTable1 :\n\0",bloc);
             for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,maskInOutGPOLocateTable1[cpt]);
             }  
             sprintf(bloc,"%s\nseuilInOutGPOLocateTable1 :\n\0",bloc);
             for(cpt=0; cpt<NB_GPIO; cpt++) {                   
                   sprintf(bloc,"%s%x\n\0",bloc,seuilInOutGPOLocateTable1[cpt]);
             }
    #ifdef SERVEUR                
            if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);
    #endif                   
       break; 
    case 29: nbSeuilPhotodiode = atoi(valeur);
    break;   
    case 30: 
         posTab2=0;
         posTab =0;
         cpt=0;
         for(cpt=0; cpt<nbSeuilPhotodiode-1; cpt ++) {
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            }	
            tableau[j]='\0';
            posTab2+=posTab+1; 
            sscanf(tableau,"%f",&seuilPhotodiodeIncrease[cpt]);
            //seuilTemp[cpt] = atoi(tableau);
         } 
         sscanf(&valeur[posTab2],"%f",&seuilPhotodiodeIncrease[cpt]);         
    #ifdef SERVEUR  
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif  
     for(cpt=0; cpt<nbSeuilPhotodiode-1; cpt ++) {
         printf("seuilPhotodiodeIncrease[%d]=%f\n",cpt,seuilPhotodiodeIncrease[cpt]);                
     }       
    break;
    case 31: 
         posTab2=0;
         posTab =0;
         
         for(cpt=0; cpt<nbSeuilPhotodiode-1; cpt ++) {
            posTab = strpos(&valeur[posTab2],",");
            for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];
            }	
            tableau[j]='\0';
            posTab2+=posTab+1; 
            sscanf(tableau,"%f",&seuilPhotodiodeDecrease[cpt]);
         } 
         sscanf(&valeur[posTab2],"%f",&seuilPhotodiodeDecrease[cpt]);         
    #ifdef SERVEUR  
         sprintf(bloc,"%s accepted",parametre);
         if(socketFlg) write(client_socket,bloc, SIZE_BUFFER);         
    #endif  

     for(cpt=0; cpt<nbSeuilPhotodiode-1; cpt ++) {
         printf("seuilPhotodiodeDecrease[%d]=%f\n",cpt,seuilPhotodiodeDecrease[cpt]);                
     }       
    break;                    
       }
	return((pos)+(pos2)+strlen(finParametre));
}
else return(0);
}

void finPrg(void){
/** Description : Prepare le fin du programme (socket) */
/** detail de la fonction : */	
 
/** shutdown() des sockets */
/** close() des sockets et file descriptor (driver)*/
shutdown(ma_socket,2);
shutdown(ma_socketMessage,2);
close(ma_socket);
close(ma_socketMessage);
close(file_desc);
}

void reset() {
/** Description : re-initialise tous les variables */
/** 
  moyTemp[][]
  valeurMoyTemp[]
  etat[]
  etatMax
  et arrete les ventillateurs
  cmdAllFan()
*/
     int cpt,cpt2;
         for(cpt=0; cpt<NB_SENSOR; cpt++) for(cpt2=0; cpt2<tempNbMoy; cpt2++) moyTemp[cpt][cpt2]=0;
         for(cpt=0; cpt<NB_SENSOR; cpt++) valeurMoyTemp[cpt]=0;
         for(cpt=0; cpt<NB_FAN; cpt++) calculFan[cpt]=0;
         for(cpt=0; cpt<NB_SENSOR; cpt++) etat[cpt]=0;
         etatMax=0;
         cmdAllFan(0);
}

void cmdAllFan(int value) {
/** Description : Permet de metre tous les ventillateurs  une certaines vitesse */
/** -> 0 = Arret
    -> FF = Maximum
	-> Val = Valeur intermediare
*/
#ifdef SERVEUR  
     int cpt;
     for(cpt=0; cpt<NB_FAN; cpt++) { 
            cPCI_Zone_Fan_DAC_Register_Write(file_desc, cpt, value);       
            cPCI_Zone_Fan_DAC_Register_Read(file_desc, cpt);
            cPCI_Fan_Status_Read(file_desc,&val);
            valeurLuFan[cpt] = val;
     }  
#endif
}

void tempFanlocateTable(char *valeur) {
/** Description : Permet de ranger dans le tableau tempFanTable[][][] le contenu de chaine */
/** detail de la fonction : */	
         int sensor=0;
         int posTab2=0;
         int posTab =0;
         int cpt=0;
         int cpt2=0;
         int j,i;
  	     char tableau[80];       
 /** -> trouve le numero de la sonde dans la chaine            */
         posTab = strpos(&valeur[posTab2],",");
         for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
           tableau[j]=valeur[i];         
         }	
         tableau[j]='\0';
         posTab2+=posTab+1; 
         sscanf(tableau,"%d",&sensor);
         sensor-=1;
 /** -> recupere le reste du contenu de la chaine et range tempFanTable[%d][%d][%d] */
         for(cpt=0; cpt<nbSeuilTemp; cpt ++) { 
           for(cpt2=0; cpt2<NB_FAN; cpt2++) {                         
              posTab = strpos(&valeur[posTab2],",");
              for(j=0, i=posTab2 ; i<posTab+posTab2; j++,i++){ 
		            tableau[j]=valeur[i];		            
              }	
              tableau[j]='\0';
              posTab2+=posTab+1; 
              sscanf(tableau,"%x",&tempFanTable[sensor][cpt][cpt2]);
              printf("tempFanTable[%d][%d][%d] = %d\n",sensor,cpt,cpt2,tempFanTable[sensor][cpt][cpt2]);
		   }
         } 
}    


